var landing = implement("smp:external/superhero_landing");

function init(hero) {
    hero.setName("The Entity");
    hero.setTier(9);
    
    hero.setHelmet("Helmet");
    hero.setChestplate("Chestplate");
    hero.setLeggings("Leggings");
    hero.setBoots("Boots");
    
    hero.addPowers("smp:code");
    hero.addAttribute("PUNCH_DAMAGE", 10, 0);
    hero.addAttribute("JUMP_HEIGHT", 1.7, 0);
    hero.addAttribute("FALL_RESISTANCE", 1, 1);
    hero.addAttribute("SPRINT_SPEED", 0.3, 1);
    hero.addAttribute("WEAPON_DAMAGE", -0.95, 1);

    hero.addKeyBind("CHARGED_BEAM", "Wrath of the Code", 1);
    hero.addKeyBind("ENERGY_PROJECTION", "Code Energy", 2);
    hero.addKeyBind("TELEPORT", "Teleport", 3);
    hero.addKeyBind("TELEKINESIS", "Telekinesis", 4);

    hero.setKeyBindEnabled(isKeyBindEnabled);

    hero.setTickHandler((entity, manager) => {
        landing.tick(entity, manager);
    });
}

function isKeyBindEnabled(entity, keyBind) {
    switch (keyBind) {
    case "CHARGED_BEAM":
        return !entity.getData("fiskheroes:telekinesis") && !(entity.isSprinting() && entity.getData("fiskheroes:flying"));
    case "ENERGY_PROJECTION":
        return !entity.getData("fiskheroes:telekinesis");
    case "TELEKINESIS":
        return !(entity.isSprinting() && entity.getData("fiskheroes:flying"));
    default:
        return true;
    }
}

function hasProperty(entity, property) {
    return property == "BREATHE_SPACE";
}
