function init(hero) {
    hero.setName("Kade Killious");
    hero.setTier(8);
    
    hero.setHelmet("item.superhero_armor.piece.mask");
    hero.setChestplate("item.superhero_armor.piece.chestpiece");
    hero.setLeggings("item.superhero_armor.piece.pants");
    hero.setBoots("item.superhero_armor.piece.boots");
    
    hero.addPowers("smp:kade_killious");
    hero.addAttribute("PUNCH_DAMAGE", 8.0, 0);
    hero.addAttribute("WEAPON_DAMAGE", 4.0, 0);
    hero.addAttribute("FALL_RESISTANCE", 8.0, 0);
    hero.addAttribute("SPRINT_SPEED", 0.2, 1);

    hero.addKeyBind("ENERGY_PROJECTION", "key.energyProjection", 1);
    hero.addKeyBind("TELEKINESIS", "key.telekinesis", 2);
    hero.addKeyBind("SHIELD", "Energy Wall", 3);
    hero.addKeyBind("BLADE", "Toggle Axe", 5);

    hero.addAttributeProfile("SHIELD", shieldProfile);
    hero.addAttributeProfile("AXE", axeProfile);
    hero.setAttributeProfile(getAttributeProfile);
    hero.setKeyBindEnabled(isKeyBindEnabled);
}

function getAttributeProfile(entity) {
    return entity.getData("fiskheroes:shield_blocking") ? "SHIELD" : entity.getData("fiskheroes:blade") ? "AXE" : null;
}

function shieldProfile(profile) {
    profile.inheritDefaults();
    profile.addAttribute("BASE_SPEED", -0.4, 1);
    profile.addAttribute("SPRINT_SPEED", 0.0, 1);
}

function axeProfile(profile) {
    profile.inheritDefaults();
    profile.addAttribute("PUNCH_DAMAGE", 10.5, 0);
}

function isKeyBindEnabled(entity, keyBind) {
    switch (keyBind) {
    case "ENERGY_PROJECTION":
        return !entity.getData("fiskheroes:blade") && !entity.getData("fiskheroes:telekinesis") && entity.getData("fiskheroes:shield_blocking_timer") == 0;
    case "TELEKINESIS":
        return entity.getData("fiskheroes:energy_projection_timer") == 0 && entity.getData("fiskheroes:shield_blocking_timer") == 0;
    case "SHIELD":
        return !entity.getData("fiskheroes:blade") && entity.getData("fiskheroes:energy_projection_timer") == 0 && !entity.getData("fiskheroes:telekinesis");
    case "BLADE":
        return entity.getData("fiskheroes:energy_projection_timer") == 0 && entity.getData("fiskheroes:shield_blocking_timer") == 0;
    default:
        return true;
    }
}