var speedster_base = implement("fiskheroes:external/speedster_base");

function init(hero) {
    hero.setName("Speedburst");
    hero.setTier(6);
    
    hero.setHelmet("Helmet");
    hero.setChestplate("Chestplate");
    hero.setLeggings("Leggings");
    hero.setBoots("Boots");
    
    hero.addPowers("smp:speedburst_suit");
    hero.addAttribute("PUNCH_DAMAGE", 5, 0);
    hero.addAttribute("JUMP_HEIGHT", 1.7, 0);
    hero.addAttribute("BASE_SPEED_LEVELS", 5.0, 0);

    hero.addKeyBind("CHARGE_ENERGY", "key.chargeEnergy", -2);
    hero.addKeyBind("SUPER_SPEED", "key.superSpeed", 1);
    hero.addKeyBind("CHARGED_BEAM", "Lightning Blast", 2);
    hero.addKeyBind("INTANGIBILITY", "Phase", 3);
    hero.addKeyBind("SLOW_MOTION", "key.slowMotion", 4);
    hero.addKeyBind("BLADE", "Toggle Lightning Sword", 5);

    hero.addSoundEvent("MASK_OPEN", "fiskheroes:cowl_mask_open");
    hero.addSoundEvent("MASK_CLOSE", "fiskheroes:cowl_mask_close");

    hero.setKeyBindEnabled(isKeyBindEnabled);
    hero.addAttributeProfile("BLADE", bladeProfile);
    hero.addAttributeProfile("BEAM", beamProfile);
    hero.setAttributeProfile(getProfile);
    hero.setDamageProfile(getProfile);
    hero.addDamageProfile("BLADE", {"types": {"ELECTRICITY": 1.0}});

    hero.setHasProperty((entity, property) => property == "MASK_TOGGLE");

    hero.setTickHandler((entity, manager) => {
        speedster_base.tick(entity, manager);
    });
}

function isKeyBindEnabled(entity, keyBind) {
    switch (keyBind) {
    case "INTANGIBILITY":
        return entity.getData("fiskheroes:speeding") && !entity.isOnGround();
    case "CHARGED_BEAM":
        return entity.getData("fiskheroes:blade");
    default:
        return true;
    }
}

function bladeProfile(profile) {
    profile.inheritDefaults();
    profile.addAttribute("PUNCH_DAMAGE", 9.0, 0);
}

function beamProfile(profile) {
    profile.inheritDefaults();
    profile.addAttribute("BASE_SPEED", -1.0, 1);
}

function getProfile(entity) {
    return entity.getData("fiskheroes:beam_shooting") ? "BEAM" : entity.getData("fiskheroes:blade") ? "BLADE" : null;
}
