function init(hero) {
    hero.setName("Thundercrash");
    hero.setTier(8);

    hero.setChestplate("item.superhero_armor.piece.torso");

    hero.addPowers("smp:dark_gamma_radiation");
    hero.addAttribute("PUNCH_DAMAGE", 10.5, 0);
    hero.addAttribute("SPRINT_SPEED", 0.8, 1);
    hero.addAttribute("JUMP_HEIGHT", 2.5, 0);
    hero.addAttribute("FALL_RESISTANCE", 1.0, 1);

    hero.addKeyBind("CHARGED_BEAM", "Thunderclap", 1);
    hero.addKeyBind("GROUND_SMASH", "key.groundSmash", 2);
    hero.addKeyBind("GAMMA", "Gamma Transformation", 5);

    hero.setModifierEnabled(isModifierEnabled);
    hero.setKeyBindEnabled(isKeyBindEnabled);
    hero.setTierOverride(entity => entity.getData("smp:dyn/gamma") ? 8 : 0);

    hero.setAttributeProfile(entity => entity.getData("smp:dyn/gamma") ? null : "INACTIVE");
    hero.addAttributeProfile("INACTIVE", profile => {
        profile.revokeAugments();
    });

    hero.setDamageProfile(entity => entity.getData("smp:dyn/gamma") && !entity.getHeldItem().isWeapon() ? "PUNCH" : null);
    hero.addDamageProfile("PUNCH", {
        "types": {
            "BLUNT": 1.0,
            "ELECTRICITY": 0.2
        }
    });

    hero.setTickHandler((entity, manager) => {
        manager.setData(entity, "fiskheroes:size_state", entity.getData("smp:dyn/gamma") ? 1 : -1)

        manager.incrementData(entity, "smp:dyn/jump_timer", 100, 1, entity.getData("smp:dyn/gamma") && entity.isSprinting())
    });
}

function isModifierEnabled(entity, modifier) {
    if (modifier.name() != "fiskheroes:transformation" && !entity.getData("smp:dyn/gamma")) {
        return false;
    }

    var l = entity.getData("smp:dyn/jump_timer");

    switch (modifier.id()) {
        case "1":
            return l >= 0 && l < 0.25;
        case "2":
            return l >= 0.25 && l < 0.5;
        case "3":
            return l >= 0.5 && l < 0.75;
        case "4":
            return l >= 0.75 && l < 1;
        case "5":
            return l == 1;
        default:
            return true;
    }
}

function isKeyBindEnabled(entity, keyBind) {
    if (keyBind != "GAMMA") {
        return entity.getData("smp:dyn/gamma");
    }

    return true;
}
