extend("fiskheroes:hero_basic");
loadTextures({
    "layer1": "smp:captain_kaisa_layer1",
    "layer2": "smp:captain_kaisa_layer2"
});

var utils = implement("fiskheroes:external/utils");

var binary;
var beam;

function initEffects(renderer) {
    utils.bindTrail(renderer, "fiskheroes:shazam");

    utils.bindBeam(renderer, "fiskheroes:repulsor_blast", "smp:heal", "rightArm", 0xCE8948, [
        { "firstPerson": [-4.5, 3.75, -8.0], "offset": [-0.5, 9.0, 0.0], "size": [2.5, 2.5] }
    ]);

    beam = utils.createLines(renderer, "smp:heal", 0x20A1D8, [
        {"start": [0.0, 0.0, 0.0], "end": [0.0, 24.0, 0.0], "size": [36.0, 36.0]}
    ]);
    beam.anchor.set("rightArm");
    beam.setOffset(1, 10, 0);

    utils.bindBeam(renderer, "fiskheroes:charged_beam", "smp:heal", "rightArm", 0xCE8948, [
        { "firstPerson": [-4.5, 3.75, -8.0], "offset": [-0.5, 9.0, 0.0], "size": [2.5, 2.5] }
    ]);

    binary = utils.createLines(renderer, "smp:binary", 0xCE8948, [
        {"start": [0.0, 0.0, 0.0], "end": [0.0, 1.0, 0.0], "size": [1.0, 1.0]}
    ]);

    flight = utils.createLines(renderer, "smp:binary_flight", 0xCE8948, [
        {"start": [0.0, 0.0, 0.0], "end": [0.0, 16.0, 0.0], "size": [1.0, 1.0]}
    ]);
    flight.anchor.set("body");
    flight.setScale(36, 3, 20);
    flight.setRotation(12.5, 0, 0);
    flight.setOffset(0, 8, 0);

    trail = renderer.bindProperty("fiskheroes:trail");
    trail.setTrail(renderer.createResource("TRAIL", "smp:binary"));
    trail.setCondition(entity => entity.isSprinting() && entity.getData("fiskheroes:flying"));
}

function initAnimations(renderer) {
    parent.initAnimations(renderer);
    renderer.removeCustomAnimation("basic.CHARGED_BEAM");

    addAnimation(renderer, "basic.CHARGED_BEAM", "fiskheroes:aiming").setData((entity, data) => 
        data.load(Math.max(entity.getInterpolatedData("fiskheroes:beam_charge") * 2.5 - 1.5, 0)));

    utils.addFlightAnimation(renderer, "captain_kaisa.FLIGHT", "fiskheroes:flight/default.anim.json");
    utils.addHoverAnimation(renderer, "captain_kaisa.HOVER", "fiskheroes:flight/idle/default");
}

function render(entity, renderLayer, isFirstPersonArm) {
    var charge = Math.max(entity.getInterpolatedData("fiskheroes:beam_charge") * 6 - 5, 0);
    beam.opacity = charge;
    beam.progress = charge;
    beam.render();

    var mode = entity.getInterpolatedData("fiskheroes:dyn/steel_timer");
    binary.anchor.set("head");
    binary.mirror = false;
    binary.opacity = mode;
    binary.setOffset(0, -9, 0);
    binary.setScale(36, 10, 36);
    binary.render();

    binary.anchor.set("body");
    binary.mirror = false;
    binary.opacity = mode;
    binary.setOffset(0, -0.5, 0.25);
    binary.setScale(35, 13.5, 20);
    binary.render();

    binary.anchor.set("rightArm");
    binary.mirror = true;
    binary.opacity = mode;
    binary.setOffset(1, -2.5, 0);
    binary.setScale(19, 13, 19);
    binary.render();

    binary.anchor.set("rightLeg");
    binary.mirror = true;
    binary.opacity = mode;
    binary.setOffset(0, -0.5, 0);
    binary.setScale(19, 13.5, 19);
    binary.render();

    var boost = entity.getInterpolatedData("fiskheroes:flight_boost_timer");
    flight.opacity = boost;
    flight.progress = boost;
    flight.render();
}
