extend("fiskheroes:spider_man_base");
loadTextures({
    "layer1": "smp:jeweled_spider_layer1",
    "layer2": "smp:jeweled_spider_layer2",
    "symbiote": "smp:jeweled_spider_symbiote.tx.json",
    "def_web": "smp:web",
	"def_web_large": "smp:web_24",
	"def_web_rope": "smp:web_rope",
    "web": "smp:jeweled_spider_symbiote_web",
	"web_large": "smp:jeweled_spider_symbiote_web_24",
	"web_rope": "smp:jeweled_spider_symbiote_web_rope",
    "blade": "smp:jeweled_spider_symbiote_blade",
    "segment": "smp:jeweled_spider_symbiote_arm",
    "claw": "smp:jeweled_spider_symbiote_claw"
});

function initEffects(renderer) {
    renderer.bindProperty("fiskheroes:equipment_wheel").color.set(0x7754A4);

    symbiote = renderer.createEffect("fiskheroes:overlay");
    symbiote.texture.set("symbiote");

    webs = renderer.bindProperty("fiskheroes:webs");

    blade = renderer.createEffect("fiskheroes:shield");
    blade.texture.set("blade");
    blade.anchor.set("rightArm");
    blade.setOffset(1.5, 10.5, 0.0).setRotation(-5, 0, 0);
    blade.large = true;

    var arm = utils.createModel(renderer, "smp:jeweled_spider_symbiote_arm", "segment");
    var claw = utils.createModel(renderer, "smp:jeweled_spider_symbiote_claw", "claw");
    claw.bindAnimation("fiskheroes:ock_claw").setData((entity, data) => {
        var t = entity.as("TENTACLE");
        data.load(0, 1 - Math.min(t.getCaster().getInterpolatedData("fiskheroes:tentacle_extend_timer") * 2, 1));
        data.load(1, t.getIndex());
        data.load(2, t.getGrabTimer());
    });

    var tentacles = renderer.bindProperty("fiskheroes:tentacles").setTentacles([
        { "offset": [2.0, -4.5, -2.0], "direction": [13.0, 10.0, -10.0] },
        { "offset": [-2.0, -4.5, -2.0], "direction": [-13.0, 10.0, -10.0] },
        { "offset": [2.0, -7.5, -2.0], "direction": [13.0, -10.0, -10.0] },
        { "offset": [-2.0, -7.5, -2.0], "direction": [-13.0, -10.0, -10.0] }
    ]);
    tentacles.anchor.set("body");
    tentacles.setSegmentModel(arm);
    tentacles.setHeadModel(claw);
    tentacles.segmentLength = 1.8;
    tentacles.segments = 16;
}

function render(entity, renderLayer, isFirstPersonArm) {
    symbiote.opacity = Math.min(entity.getInterpolatedData("fiskheroes:dyn/nanite_timer") * 4, 1);
    symbiote.render();

    var sym = entity.getData("fiskheroes:dyn/nanites");
    webs.textureSmall.set(sym ? "web" : "def_web");
    webs.textureLarge.set(sym ? "web_large" : "def_web_large");
    webs.textureRope.set(sym ? "web_rope" : "def_web_rope");
    webs.textureRopeBase.set(sym ? "web" : "def_web");

    blade.unfold = entity.getInterpolatedData("fiskheroes:blade_timer");
    blade.render();
}