extend("fiskheroes:hero_basic");
loadTextures({
    "layer1": "smp:the_son_layer1",
    "layer2": "smp:the_son_layer2",
    "left_arm": "smp:the_son_left_arm",
    "right_arm": "smp:the_son_right_arm"
});

var utils = implement("fiskheroes:external/utils");

function initEffects(renderer) {
    utils.bindBeam(renderer, "fiskheroes:energy_projection", "smp:charged_beam", "rightArm", 0xCC0000, [
        { "firstPerson": [-3.75, 3.0, -8.0], "offset": [-0.5, 9.0, 0.0], "size": [1.5, 1.5] },
        { "firstPerson": [3.75, 3.0, -8.0], "offset": [-0.5, 9.0, 0.0], "size": [1.5, 1.5], "anchor": "leftArm" }
    ]).setParticles(renderer.createResource("PARTICLE_EMITTER", "fiskheroes:impact_charged_beam"));

    renderer.bindProperty("fiskheroes:opacity").setOpacity((entity, renderLayer) => {
        return 0.99999;
    });

    left_arm = renderer.createEffect("fiskheroes:model");
    left_arm.setModel(utils.createModel(renderer, "smp:alex_arm", "left_arm"));
    left_arm.anchor.set("leftArm");
    left_arm.setOffset(-0.5, -14, 0)

    right_arm = renderer.createEffect("fiskheroes:model");
    right_arm.setModel(utils.createModel(renderer, "smp:alex_arm", "left_arm"));
    right_arm.anchor.set("rightArm");
    right_arm.setOffset(0.5, -14, 0)
}

function initAnimations(renderer) {
    parent.initAnimations(renderer);
    renderer.removeCustomAnimation("basic.CHARGED_BEAM");
    renderer.removeCustomAnimation("basic.ENERGY_PROJ");

    addAnimationWithData(renderer, "basic.ENERGY_PROJ", "fiskheroes:dual_aiming", "fiskheroes:energy_projection_timer");

    utils.addHoverAnimation(renderer, "strange.HOVER", "fiskheroes:flight/idle/neutral");
    utils.addFlightAnimation(renderer, "strange.FLIGHT", "smp:flight/levitate.anim.json", (entity, data) => {
        data.load(entity.getInterpolatedData("fiskheroes:flight_timer"));
    });
}

function render(entity, renderLayer, isFirstPersonArm) {
    if (renderLayer == "CHESTPLATE") {
        right_arm.render();
        left_arm.render();
    }
}
